#ifndef ndestylewidgetstateengine_h
#define ndestylewidgetstateengine_h

#include "ndestyle.h"
#include "ndestylebaseengine.h"
#include "ndestyledatamap.h"
#include "ndestylewidgetstatedata.h"

namespace NdeStyle
{

class WidgetStateEngine: public BaseEngine
{

    Q_OBJECT
public:
    explicit WidgetStateEngine( QObject* parent );

    virtual ~WidgetStateEngine( void );

    QList<RippleData> ripples( const QObject* object );
    virtual bool registerWidget( QWidget* widget);

    //设置波纹圆心
    void setRippleDataPoint(const QObject* widget,QPoint center);
    //设置波纹半径
    void setRippleDataRadius(const QObject* widget,int radius);
public Q_SLOTS:
    virtual bool unregisterWidget( QObject* object );
protected:
    DataMap<WidgetStateData>::Value data(const QObject* object);
    DataMap<WidgetStateData>& dataMap();
private:
    DataMap<WidgetStateData> m_data;
};



class WidgetStateWidthEngine: public BaseEngine
{

    Q_OBJECT
public:
    explicit WidgetStateWidthEngine( QObject* parent );

    virtual ~WidgetStateWidthEngine( void );

    QList<RippleWidthData> widthRipples( const QObject* object);
    virtual bool registerWidget( QWidget* widget);
    void setRippleDataWidth(const QObject *widget, qreal width);
public Q_SLOTS:
    virtual bool unregisterWidget( QObject* object );
protected:
    DataMap<WidgetStateWidthData>::Value data(const QObject* object);
    DataMap<WidgetStateWidthData>& dataMap();
private:
    DataMap<WidgetStateWidthData> m_WidthData;
};

}

#endif
