#ifndef ndestylemnemonics_h
#define ndestylemnemonics_h

#include <QEvent>
#include <QObject>
#include <QApplication>

namespace NdeStyle
{

    class Mnemonics: public QObject
    {

        Q_OBJECT

        public:

        //* constructor
        explicit Mnemonics( QObject* parent ):
            QObject( parent ),
            _enabled( true )
            {}

        //* destructor
        virtual ~Mnemonics( void )
        {}

        //* set mode
        void setMode( int );

        //* event filter
        virtual bool eventFilter( QObject*, QEvent* );

        //* true if mnemonics are enabled
        const bool& enabled( void ) const
        { return _enabled; }

        //* alignment flag
        int textFlags( void ) const
        { return _enabled ? Qt::TextShowMnemonic : Qt::TextHideMnemonic; }

        protected:

        //* set enable state
        void setEnabled( bool );

        private:

        //* enable state
        bool _enabled;

    };

}

#endif
