#ifndef COMBOXEVENTFILTER_H
#define COMBOXEVENTFILTER_H

#include <QObject>
#include <QWidget>
#include <QPropertyAnimation>

class QAbstractItemView;

class ComboxEventFilter : public QObject
{
    Q_OBJECT
public:
    explicit ComboxEventFilter(QObject *parent = nullptr);

protected:
    virtual bool eventFilter(QObject *watched, QEvent *event);

private :
    void resetAnimation(QAbstractItemView * itemView);

private Q_SLOTS:
    void animationFinished();

private:
    QPropertyAnimation * _animation;
    Qt::ScrollBarPolicy _vScrollBarPolicy;
    QRect _rect;
};

#endif // COMBOXEVENTFILTER_H
